package com.imcode.forum.shell;

import com.imcode.forum.ForumRepository;
import com.imcode.forum.Id;
import com.imcode.forum.Forum;

import java.io.PrintStream;

class CreateForumCommand implements ForumShellCommand {

    public void execute(ForumRepository repository, PrintStream out, String[] commandParameters) {
        Id id = repository.createId(Integer.parseInt(commandParameters[0]));
        if ( null != repository.getForum(id) ) {
            out.println("Forum " + id + " already exists.");
        } else {
            Forum newForum = repository.createForum(id);
            out.println("Created " + newForum);
        }
    }

    public String[] getParameterNames() {
        return new String[] { "forum-id" };
    }

    public String getPurpose() {
        return "Create forum" ;
    }

}
