package com.imcode.forum.sql;

public class MssqlForumDdl implements ForumDdl {
    private static final String MSSQL_DDL__FORUMS = "CREATE TABLE forum_forums (\n"
                                                    + "forum_id INT NOT NULL PRIMARY KEY\n"
                                                    + ")" ;


    private static final String MSSQL_DDL__THREADS = "CREATE TABLE forum_threads (\n"
                                                     + "thread_id INT NOT NULL IDENTITY PRIMARY KEY,\n"
                                                     + "forum_id INT NOT NULL,\n"
                                                     + "FOREIGN KEY (forum_id) REFERENCES forum_forums(forum_id)\n"
                                                     + ")" ;

    private static final String MSSQL_DDL__POSTS = "CREATE TABLE forum_posts (\n"
                                                   + "post_id INT NOT NULL IDENTITY PRIMARY KEY,\n"
                                                   + "thread_id INT NOT NULL,\n"
                                                   + "parent_post_id INT,\n"
                                                   + "datetime DATETIME NOT NULL,\n"
                                                   + "view_count INT NOT NULL DEFAULT 0,\n"
                                                   + "userdata NTEXT,\n"
                                                   + "title NTEXT NOT NULL,\n"
                                                   + "body NTEXT NOT NULL,\n"
                                                   + "hidden BIT NOT NULL DEFAULT 0,\n"
                                                   + "FOREIGN KEY (thread_id) REFERENCES forum_threads(thread_id)\n"
                                                   + ")" ;


    public String getForumsDdl() {
        return MSSQL_DDL__FORUMS ;
    }

    public String getThreadsDdl() {
        return MSSQL_DDL__THREADS ;
    }

    public String getPostsDdl() {
        return MSSQL_DDL__POSTS ;
    }
}